<template>
  <div>
    <form-wizard
      @on-complete="confirmApplyEnvironment"
      shape="circle"
      color="#20a0ff"
      error-color="#ff4949"
      title=""
      subtitle=""
    >
      <tab-content
        title="Select Scenario"
        icon="el-icon-goods"
        :before-change="validateFirstStep"
      >
        <Card
          @getClickEvt="setType"
          :selected-type="selectedType"
        />
      </tab-content>
      <tab-content
        title="Select Environment"
        icon="el-icon-s-operation"
        :before-change="validateSecondStep"
      >
        <SearchResource
          :lab-item="true"
          :name-item="false"
          @getSearchData="getAvailbleEnv"
        />
        <div class="tableDiv">
          <el-row>
            <el-col
              :span="24"
              class="table"
            >
              <el-table
                :data="currPageTableData"
                border
                highlight-current-row
                @current-change="applyEnvironment"
              >
                <el-table-column
                  prop="envName"
                  :label="$t('env.name')"
                />
                <el-table-column
                  prop="lab"
                  :label="$t('env.lab')"
                />
                <el-table-column
                  :label="$t('env.status')"
                >
                  <template slot-scope="scope">
                    <span
                      :style="getStatusColor(scope.row.status)"
                    >
                      {{ $t(scope.row.status) }}
                    </span>
                  </template>
                </el-table-column>
                <el-table-column
                  prop="type"
                  :label="$t('env.type')"
                />
                <el-table-column
                  prop="remarks"
                  :label="$t('env.remark')"
                />
                <el-table-column
                  :label="$t('env.operation')"
                  width="180"
                >
                  <template slot-scope="scope">
                    <el-button
                      id="editUsrBtn"
                      @click="getDetails(scope.row)"
                      type="text"
                      size="small"
                    >
                      {{ $t('env.details') }}
                    </el-button>
                  </template>
                </el-table-column>
              </el-table>
            </el-col>
          </el-row>
          <div class="pageBar">
            <Pagination
              :table-data="paginationData"
              @getCurrentPageData="getCurrentPageData"
            />
          </div>
          <el-dialog
            :title="$t('env.application')"
            :visible.sync="dialogVisible"
          />
          <el-dialog
            title="Resource Details"
            :visible.sync="resourceDetailVisible"
          >
            <div class="tableDiv">
              <el-table
                :data="resourceDetails"
                border
              >
                <el-table-column
                  type="index"
                  :label="$t('env.no')"
                  width="50"
                />
                <el-table-column
                  prop="lab"
                  :label="$t('env.lab')"
                />
                <el-table-column
                  prop="ipAddress"
                  :label="$t('env.ipAddress')"
                />
                <el-table-column
                  prop="nodeType"
                  :label="$t('env.nodeType')"
                />
                <el-table-column
                  prop="architacture"
                  :label="$t('env.architacture')"
                />
                <el-table-column
                  prop="specifications"
                  :label="$t('env.specifications')"
                />
                <el-table-column
                  prop="specialResources"
                  :label="$t('env.specialResources')"
                />
              </el-table>
            </div>
            <div
              slot="footer"
              class="dialog-footer"
            >
              <el-button
                id="cancelBtn"
                @click="resourceDetailVisible = false"
              >
                {{ $t('common.cancel') }}
              </el-button>
            </div>
          </el-dialog>
        </div>
      </tab-content>
      <tab-content
        title="Usage Details"
        icon="el-icon-s-claim"
        :before-change="validateThirdStep"
      >
        <el-form
          label-width="180px"
          :rules="rules"
          ref="currentData"
          class="demo-ruleForm"
          :model="currentData"
        >
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.duration')"
            >
              <el-select
                id="duration"
                v-model="currentData.duration"
                prop="duration"
                default-first-option
              >
                <el-option
                  v-for="item in duration"
                  :key="item"
                  :label="item"
                  :value="item"
                />
              </el-select>
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.testCard')"
              prop="testCard"
            >
              <el-input-number
                controls-position="right"
                :min="1"
                :max="10"
                v-model="currentData.testCard"
              /> Number
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              prop="testOnSite"
              label-width="300px"
              :label="$t('env.testonsitelabel')"
            >
              <el-switch
                v-model="currentData.testOnSite"
              />
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.remark')"
            >
              <el-input
                type="textarea"
                v-model="currentData.requestRemarks"
                :rows="3"
                :placeholder="$t('env.remarkDetails')"
              />
            </el-form-item>
          </div>
        </el-form>
      </tab-content>
      <el-button
        type="primary"
        slot="prev"
      >
        Back
      </el-button>
      <el-button
        type="primary"
        slot="next"
      >
        Next
      </el-button>
      <el-button
        type="primary"
        slot="finish"
      >
        Finish
      </el-button>
    </form-wizard>
  </div>
</template>
<script>
import SearchResource from '../../components/SearchResource.vue'
import Pagination from '../../components/Pagination.vue'
import Card from '../../components/Card.vue'
import axios from 'axios'
import { BASE_URL } from '../../tools/constant.js'
export default {
  name: 'EnvRequest',
  components: {
    SearchResource,
    Pagination,
    Card
  },
  data () {
    return {
      getEnvDataList: [],
      dialogVisible: false,
      currentData: {},
      duration: ['1 Week', '1 Month', '1 Year'],
      resourceDetails: [],
      resourceDetailVisible: false,
      paginationData: [],
      currPageTableData: [],
      rules: {
        duration: [
          { required: true, message: 'Select time duration for environment.', trigger: 'blur' }
        ],
        testCard: [
          { required: true, message: 'Test Card cannot be empty.', trigger: 'blur' }
        ]
      },
      selectedType: ''
    }
  },
  beforeMount () {
  },
  methods: {
    getStatusColor (status) {
      let statusColor = {}
      switch (status) {
        case 'Available':
          statusColor = { 'color': '#327ace' }
          break
        case 'Waiting':
          statusColor = { 'color': '#eeae5a' }
          break
        case 'Rejected':
          statusColor = { 'color': '#e82003' }
          break
        case 'Assigned':
        case 'Approved':
          statusColor = { 'color': '#3fa981' }
          break
      }
      return statusColor
    },
    submitForm (formName) {
      let isValid = false
      this.$refs[formName].validate((valid) => {
        if (valid) {
          isValid = true
        } else {
          console.log('error submit!!')
          return false
        }
      })
      return isValid
    },
    validateFirstStep () {
      if (!this.currentData.type) {
        this.$parent.$parent.errorMessage(this.$t('confirm.selectScenario'))
        return false
      }
      this.getAvailbleEnv()
      return true
    },
    validateSecondStep () {
      if (!this.currentData.envName) {
        this.$parent.$parent.errorMessage(this.$t('confirm.selectEnv'))
        return false
      }
      return true
    },
    validateThirdStep () {
      let isValid = this.submitForm('currentData')
      return isValid
    },
    setType (type) {
      this.selectedType = type
      this.currentData.type = type
    },
    getCurrentPageData (data) {
      this.currPageTableData = data
    },
    getDetails (data) {
      let url = BASE_URL + '/getResourceDetails?envName=' + data.envName
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.resourceDetailVisible = true
        this.resourceDetails = res.data
      }, error => {
        if (error) {
          this.resourceDetailVisible = false
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    getAvailbleEnv (data) {
      if (!data) {
        data = {
          name: '',
          lab: 'ALL'
        }
      }
      data.type = this.currentData.type
      let url = `${BASE_URL}/getAvailableEnvironments?name=${data.name}&type=${data.type}&lab=${data.lab}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationData = res.data
      }, error => {
        if (error) {
          this.$parent.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    applyEnvironment (data) {
      if (!this.currentData) {
        this.currentData = {}
      }
      this.currentData = data
      this.currentData.type = this.selectedType
    },
    cancel () {
      this.dialogVisible = false
    },
    confirmApplyEnvironment () {
      this.currentData['userId'] = sessionStorage.getItem('userId')
      this.currentData.testOnSite = this.currentData.testOnSite ? 'Yes' : 'No'

      let url = BASE_URL + '/addEnvRequest'
      axios({
        method: 'POST',
        url: url,
        data: this.currentData,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.$parent.successMessage(this.$t('confirm.confirmApplyEnv'))
        this.currentData = {}
        this.dialogVisible = false
        this.$emit('cancelDialog', true)
      }, error => {
        if (error) {
          this.$parent.$parent.errorMessage(this.$t(error.response.data))
          this.currentData = {}
        }
      })
    }
  }
}
</script>
<style>
</style>
